<script lang="ts">
import Vue from 'vue';
import FormTabsCard from './form-tabs-card.vue';
import CodeSuggestionsSalesFormWrapper from './gitlab-duo-workflow-form-wrapper.vue';

export default Vue.extend({
  name: 'FormTabs',
  components: {
    FormTabsCard,
    CodeSuggestionsSalesFormWrapper,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: () => {},
    },
    param: {
      type: String,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      selectedTab: this.param ? this.param : 'free-trial',
    };
  },
  methods: {
    onFormSubmit() {
      this.$emit('submit');
    },
    toggleTab(id) {
      this.selectedTab = id;
    },
  },
});
</script>

<template>
  <article class="form-tabs-container" role="tablist">
    <div class="tab-controls">
      <div class="tab-controls__inner">
        <button
          v-for="tab in data.tabs"
          :id="`${tab.tabId}-tab`"
          :key="tab.tabId"
          role="tab"
          :aria-selected="selectedTab === tab.tabId"
          :aria-controls="`${tab.tabId}-panel`"
          :data-ga-name="tab.buttonText.toLowerCase()"
          data-ga-location="body"
          :class="selectedTab === tab.tabId ? 'active' : ''"
          @click="toggleTab(tab.tabId)"
        >
          {{ tab.buttonText }}
        </button>
      </div>
    </div>
    <div class="tab-content-wrapper">
      <div
        v-for="item in data.tabs"
        :id="`${item.tabId}-panel`"
        :key="`${item.tabId}-panel`"
        class="tab-content"
        :aria-labelledby="`${item.tabId}-tab`"
      >
        <div v-show="selectedTab === item.tabId" class="inner">
          <SlpTypography
            v-if="item.content.header"
            tag="div"
            variant="heading4-bold"
            class="slp-mb-16"
          >
            <div v-html="$md.render(item.content.header)"></div>
          </SlpTypography>
          <SlpTypography
            v-if="item.content.text"
            tag="div"
            variant="body2"
            class="slp-mb-24"
          >
            <div v-html="$md.render(item.content.text)" />
          </SlpTypography>
          <div v-if="item.content.cards" class="cards">
            <FormTabsCard
              v-for="card in item.content.cards"
              :key="card.header"
              :data="card"
            />
            <FormTabsCard
              :is-accordion="true"
              :data="item.content.formAccordion"
              @submit="onFormSubmit"
            />
          </div>
          <CodeSuggestionsSalesFormWrapper
            v-if="item.content.form"
            :data="item.content.form"
            :is-dark="true"
            :in-tabs="true"
          />
        </div>
      </div>
    </div>
  </article>
</template>

<style lang="scss" scoped>
.form-tabs-container {
  border-radius: 8px;
  background: linear-gradient(
      0deg,
      rgba(225, 152, 109, 0.1) 0%,
      rgba(110, 67, 211, 0.1) 100%
    ),
    #171321;
  color: $color-text-50;
  border: 1px solid $color-surface-600;

  .tab-controls {
    display: flex;
    flex-direction: row;
    flex-wrap: nowrap;

    &__inner {
      margin: 32px 32px 0 32px;
      width: 100%;
      border-bottom: 1px solid $color-surface-600;
      display: flex;
      @media (max-width: $breakpoint-md) {
        margin: 0;
      }
    }

    button {
      border: none;
      padding: 16px;
      border: none;
      border-bottom: 3px solid transparent;
      font-size: 18px;
      line-height: 28px;
      color: $color-text-50;
      cursor: pointer;

      &.active {
        border-bottom-color: $color-accent-400;
        font-weight: $font-weight-bold;
      }

      @media (max-width: $breakpoint-md) {
        font-size: 15px;
      }
    }
  }

  .tab-content-wrapper {
    padding: 32px;
    @media (max-width: $breakpoint-md) {
      padding: 32px 24px;
    }
  }

  .cards {
    display: flex;
    flex-direction: column;
    gap: 24px;
  }
}
</style>
